zoukankan      html  css  js  c++  java
  • Leetcode——1. 两数之和

    难度: 简单

    题目

    Given an array of integers, return indices of the two numbers such that they add up to a specific target.
    You may assume that each input would have exactly one solution, and you may not use the same element twice.

    给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
    你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

    示例:

    给定 nums = [2, 7, 11, 15], target = 9

    因为 nums[0] + nums[1] = 2 + 7 = 9
    所以返回 [0, 1]

    PHP

    暴力解法

    暴力解法:双重循环。时间复杂度O(N^2)。

    function twoSum($nums, $target) {
        $count = count($nums);
        for($i=0; $i< $count; $i++){
            for($j=$i+1; $j< $count; $j++){
                if ($nums[$i] + $nums[$j] == $target) {
                    break 2;
                }
             }
        }
    
        return [$i, $j];   
    }
    

    使用HashMap

    hashMap法:直接去查找对应的值的key。时间复杂度O(N)。
    php里使用array模拟HashMap。 array_keys如果加了 第二个参数,表示仅返回含有该值的key。

    
    function twoSum($nums, $target) {
        $count = count($nums);
        for($i=0; $i< $count; $i++){
            $ele = $target - $nums[$i];
            $keys = array_keys($nums, $ele);
            foreach($keys as $key) {
                if ( $key &&  $key != $i) {
                    return [$i, $key]; 
                }
            }
            
        }   
    
        return [0,0]; 
    }
    

    时间复杂度:O(n)。

    改进:时间O(N),空间O(N)

    借助一个hashtable,每次循环的时候,发现当前值在table中找不到配对,先记录下来,key是值,值是与之配对的值的索引;如果当前值在table中找到配对,说明配对成功。

    function twoSum($nums, $target) {
        $table = []; //值 => 可以配对的索引
        $len = count($nums);
        for($i = 0; $i < $len; $i++ ) {
            $value = $nums[$i];
            if (isset($table[$value]))  {
                return [$table[$value], $i]; //配对成功
            } else {
                $table[$target - $nums[$i]] = $i; //记录该值配对对应的索引
            }
        }
    }
    

    二分法

    用一个排序都能把复杂度降到O(NlogN),通过排序,然后用两个指针从前后扫描逼近真值。
    注意这个思想,可以让O(N^2)的复杂度降为O(N),充分利用排序,因为一定会有一个值满足,然后通过值去原数组里找对应的下标。

    function twoSum($nums, $target) {
        $nums_c = $nums; //保留原数组,sort函数会修改原数组
        sort($nums);
        $start = 0;
        $end = $count =  count($nums);
    
        //两边逼近
        while($start < $end){
            while($nums[$start] + $nums[--$end] > $target);
            if ($nums[$start] + $nums[$end] == $target) {
                break;
            }
    
            while($nums[++$start] + $nums[$end] < $target);
            if ($nums[$start] + $nums[$end] == $target) {
                break;
            }
        }
    
        //从原始数组里查找对应值的key
        $result = [];
        for($i=0; $i < $count; $i++) {
            if ($nums_c[$i] == $nums[$start] || $nums_c[$i] == $nums[$end]) {
                $result[] = $i;
            }
        }
        
        return $result; 
    }
    

    时间复杂度:O(n)。

    来源

    链接:https://leetcode-cn.com/problems/two-sum

  • 相关阅读:
    翻转整数
    无重复字符的最长子串
    字节问题
    django model中get()和filter()方法的区别
    leetcode 290 Word Pattern(map的应用)
    leetcode 130 Surrounded Regions(BFS)
    leetcode 27 Remove Element
    leetcode 102 Binary Tree Level Order Traversal(DFS||BFS)
    leetcode 111 Minimum Depth of Binary Tree(DFS)
    leetcode 104 Maximum Depth of Binary Tree(DFS)
  • 原文地址:https://www.cnblogs.com/52fhy/p/11031351.html
Copyright © 2011-2022 走看看